#include <gst/gst.h>


int main(int argc, char *argv[]) {
  GstElement *pipeline, *bin, *equalizer, *convert, *sink;
  GstPad *pad, *ghost_pad;
  GstBus *bus;
  GstMessage *msg;

  /* Initialize GStreamer */
  gst_init (&argc, &argv);

  /* Build the pipeline */
//// pipeline = gst_parse_launch ("filesrc location=/home/gansta/Downloads/vi.mp4! decodebin ! mixer.sink_0!filesrc location=/home/gansta/Downloads/vi.mp4! decodebin ! mixer.sink_1!videomixer name=mixer sink_0::zorder=2 sink_1::zorder=3 sink_1::ypos=-25 sink_1::alpha=1    ! video/x-raw, height=540     ! videoconvert ! autovideosink", NULL);

pipeline = gst_parse_launch ("uridecodebin uri=file:///home/gansta/Downloads/vi.mp4 ! videoscale ! video/x-raw, width=520, height=340 !videobox border-alpha=0 left=0 ! videomixer name=m sink_1::xpos=20  sink_2::xpos=420 ! autovideosink uridecodebin uri=http://gansta-paradise.com/components/com_jshopping/files/img_products/thumb_logogood.png ! videoscale ! video/x-raw, width=50, height=40 ! imagefreeze !     m.sink_1  uridecodebin uri=http://gansta-paradise.com/components/com_jshopping/files/img_products/thumb_logogood.png ! videoscale ! video/x-raw, width=50, height=40 ! imagefreeze !     m.sink_2  ",NULL);
  /* Create the elements inside the sink bin */
  equalizer = gst_element_factory_make ("equalizer-3bands", "equalizer");
  convert = gst_element_factory_make ("audioconvert", "convert");
  sink = gst_element_factory_make ("autoaudiosink", "audio_sink");
  if (!equalizer || !convert || !sink) {
    g_printerr ("Not all elements could be created.\n");
    return -1;
  }

  /* Create the sink bin, add the elements and link them */
  bin = gst_bin_new ("audio_sink_bin");
  gst_bin_add_many (GST_BIN (bin), equalizer, convert, sink, NULL);
  gst_element_link_many (equalizer, convert, sink, NULL);
  pad = gst_element_get_static_pad (equalizer, "sink");
  ghost_pad = gst_ghost_pad_new ("sink", pad);
  gst_pad_set_active (ghost_pad, TRUE);
  gst_element_add_pad (bin, ghost_pad);
  gst_object_unref (pad);

  /* Configure the equalizer */
  g_object_set (G_OBJECT (equalizer), "band1", (gdouble)-24.0, NULL);
  g_object_set (G_OBJECT (equalizer), "band2", (gdouble)-24.0, NULL);

  /* Set playbin's audio sink to be our sink bin */
  g_object_set (GST_OBJECT (pipeline), "audio-sink", bin, NULL);

  /* Start playing */
  gst_element_set_state (pipeline, GST_STATE_PLAYING);

  /* Wait until error or EOS */
  bus = gst_element_get_bus (pipeline);
  msg = gst_bus_timed_pop_filtered (bus, GST_CLOCK_TIME_NONE, (GstMessageType)(GST_MESSAGE_ERROR | GST_MESSAGE_EOS));

  /* Free resources */
  if (msg != NULL)
    gst_message_unref (msg);
  gst_object_unref (bus);
  gst_element_set_state (pipeline, GST_STATE_NULL);
  gst_object_unref (pipeline);
  return 0;
}
